import copy

# Name of hyper solids (4D) is hxyz where:
# x is hyper volume - number of elementary hyper cubes
# y letter a, b, c... diferent hyper solid with same hyper volume
# z number of dimensions with length grether than 1 - flat solids have lower z

# All possible 4D hyper solids made of 1, 2, 3, 4 of 5 elementary 1x1x1x1 hyper cube,
# that feet in 2x2x2x2 hyper cube (all solid dimensions have length 2 or less) with
# coordinates of elementary hyper cubes [u, z, y, x] are in following lists:
# For easier calculation u,z,y,x are -1 or +1, elementary dimesinon is 2.

h1a0 = [ [-1, -1, -1, -1] ]
h2a1 = [ [-1, -1, -1, -1], [-1, -1, -1, 1] ]
h3a2 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1] ]
h4a2 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, -1, 1, 1] ]
h4b3 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, 1, -1, -1] ]
h4c3 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, 1, -1, 1] ]
h5a3 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, -1, 1, 1], [-1, 1, -1, -1] ]
h5b3 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, 1, -1, 1], [-1, 1, 1, -1] ]
h5c4 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, 1, -1, -1], [1, -1, -1, -1] ]
h5d4 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, 1, -1, -1], [1, -1, -1, 1] ]
h5e4 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, 1, -1, 1], [1, -1, 1, -1] ]
h5f4 = [ [-1, -1, -1, -1], [-1, -1, -1, 1], [-1, -1, 1, -1], [-1, 1, 1, -1], [1, -1, -1, 1] ]

def movx (hsolid):  # moving in x direction
    w = max(hsolid, key=lambda item: item[3])
    if w[3] < 1:
        for i in range (len(hsolid)):
            hsolid[i][3] = hsolid[i][3] + 2

def movix (hsolid):  # moving in (-x) direction
    w = min(hsolid, key=lambda item: item[3])
    if w[3] > -1:
        for i in range (len(hsolid)):
            hsolid[i][3] = hsolid[i][3] - 2

def movy (hsolid):  # moving in y direction
    w = max(hsolid, key=lambda item: item[2])
    if w[2] < 1:
        for i in range (len(hsolid)):
            hsolid[i][2] = hsolid[i][2] + 2

def moviy (hsolid):  # moving in (-y) direction
    w = min(hsolid, key=lambda item: item[2])
    if w[2] > -1:
        for i in range (len(hsolid)):
            hsolid[i][2] = hsolid[i][2] - 2

def movz (hsolid):  # moving in z direction
    w = max(hsolid, key=lambda item: item[1])
    if w[1] < 1:
        for i in range (len(hsolid)):
            hsolid[i][1] = hsolid[i][1] + 2

def moviz (hsolid):  # moving in (-z) direction
    w = min(hsolid, key=lambda item: item[1])
    if w[1] > -1:
        for i in range (len(hsolid)):
            hsolid[i][1] = hsolid[i][1] - 2

def movu (hsolid):  # moving in u direction
    w = max(hsolid, key=lambda item: item[0])
    if w[0] < 1:
        for i in range (len(hsolid)):
            hsolid[i][0] = hsolid[i][0] + 2

def moviu (hsolid):  # moving in (-u) direction
    w = min(hsolid, key=lambda item: item[0])
    if w[0] > -1:
        for i in range (len(hsolid)):
            hsolid[i][0] = hsolid[i][0] - 2

def rotxy (hsolid):  # rotate xy
    for i in range (len(hsolid)):
        hsolid[i][3], hsolid[i][2] = -hsolid[i][2], hsolid[i][3]

def rotxz (hsolid):  # rotate xz
    for i in range (len(hsolid)):
        hsolid[i][3], hsolid[i][1] = -hsolid[i][1], hsolid[i][3]

def rotxu (hsolid):  # rotate xu
    for i in range (len(hsolid)):
        hsolid[i][3], hsolid[i][0] = -hsolid[i][0], hsolid[i][3]

def rotyz (hsolid):  # rotate yz
    for i in range (len(hsolid)):
        hsolid[i][2], hsolid[i][1] = -hsolid[i][1], hsolid[i][2]

def rotyu (hsolid):  # rotate yu
    for i in range (len(hsolid)):
        hsolid[i][2], hsolid[i][0] = -hsolid[i][0], hsolid[i][2]

def rotzu (hsolid):  # rotate zu
    for i in range (len(hsolid)):
        hsolid[i][1], hsolid[i][0] = -hsolid[i][0], hsolid[i][1]

def rotyx (hsolid):  # rotate yx
    for i in range (len(hsolid)):
        hsolid[i][3], hsolid[i][2] = hsolid[i][2], -hsolid[i][3]

def rotzx (hsolid):  # rotate zx
    for i in range (len(hsolid)):
        hsolid[i][3], hsolid[i][1] = hsolid[i][1], -hsolid[i][3]

def rotux (hsolid):  # rotate ux
    for i in range (len(hsolid)):
        hsolid[i][3], hsolid[i][0] = hsolid[i][0], -hsolid[i][3]

def rotzy (hsolid):  # rotate zy
    for i in range (len(hsolid)):
        hsolid[i][2], hsolid[i][1] = hsolid[i][1], -hsolid[i][2]

def rotuy (hsolid):  # rotate uy
    for i in range (len(hsolid)):
        hsolid[i][2], hsolid[i][0] = hsolid[i][0], -hsolid[i][2]

def rotuz(hsolid):  # rotate uz
    for i in range (len(hsolid)):
        hsolid[i][1], hsolid[i][0] = hsolid[i][0], -hsolid[i][1]

def uzyx01(hsolid):  # convert coordinates (-1, +1) to (0, 1)
    for i in range (len(hsolid)):
        for c in range (4):
            if hsolid[i][c] == -1:
                hsolid[i][c] = 0

def rotfcxy(fcube):  # rotate fill cube xy
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):  # abs(y-1) is 0 for y=1 and 1 for y=0 
                    fcube[u][z][x][abs(y-1)] = fcubecopy[u][z][y][x]

def rotfcyx(fcube):  # rotate fill cube yx
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[u][z][abs(x-1)][y] = fcubecopy[u][z][y][x]

def rotfcxz(fcube):  # rotate fill cube xz
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[u][x][y][abs(z-1)] = fcubecopy[u][z][y][x]

def rotfczx(fcube):  # rotate fill cube zx
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[u][abs(x-1)][y][z] = fcubecopy[u][z][y][x]

def rotfcyz(fcube):  # rotate fill cube yz
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[u][y][abs(z-1)][x] = fcubecopy[u][z][y][x]

def rotfczy(fcube):  # rotate fill cube zy
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[u][abs(y-1)][z][x] = fcubecopy[u][z][y][x]

def rotfcxu(fcube):  # rotate fill cube xu
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[x][z][y][abs(u-1)] = fcubecopy[u][z][y][x]

def rotfcux(fcube):  # rotate fill cube ux
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[abs(x-1)][z][y][u] = fcubecopy[u][z][y][x]

def rotfcyu(fcube):  # rotate fill cube yu
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[y][z][abs(u-1)][x] = fcubecopy[u][z][y][x]

def rotfcuy(fcube):  # rotate fill cube uy
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[abs(y-1)][z][u][x] = fcubecopy[u][z][y][x]

def rotfczu(fcube):  # rotate fill cube zu
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[z][abs(u-1)][y][x] = fcubecopy[u][z][y][x]

def rotfcuz(fcube):  # rotate fill cube uz
    fcubecopy = copy.deepcopy (fcube)
    for u in range (2):
        for z in range (2):
            for y in range (2):
                for x in range (2):
                    fcube[abs(z-1)][u][y][x] = fcubecopy[u][z][y][x]


