from kivy.app import App
from kivy.uix.widget import Widget
from kivy.graphics import Color, Line, Rectangle, Ellipse,  Triangle
from kivy.clock import Clock
import copy
import hvol5_2 as h5
from kivy.uix.gridlayout import GridLayout
from kivy.uix.button import Button


class LoginScreen(GridLayout):

    def __init__(self, **kwargs):
        super(LoginScreen, self).__init__(**kwargs)
        self.cols = 3
        button = []
        for b in range(7):
            button.append ( Button(text='Start Game %d' % (b+1)) )
            self.add_widget(button[b])
            button[b].bind(on_press = self.button_callback)
            b = b + 1

    def button_callback(self, instance):
        ChooseGameApp.gamenr = int(instance.text[-1])
        App.get_running_app().stop()

     
class ChooseGameApp(App):

    def build(self):
        return LoginScreen()

    gamenr = 0


class CubeGame(Widget):
    def __init__(self, **kwargs):
        super(CubeGame, self).__init__(**kwargs)

        if kwargs is not None:
            for k in kwargs:
                if k == 'GameNumber':
                    self.gamenr = kwargs[k]
        self.init_hypersolids()
        self.hs = copy.deepcopy (self.hypersolids[0])
        self.draw4d()


    def on_touch_down(self, touch):
        if self.NoUserInputs == True or self.hypervolume == 16:
            return
        if self.SCROFS + 23 * self.ESZ / 6. < touch.x < self.SCROFS + 25 * self.ESZ / 6. and 23 * self.ESZ / 6. < touch.y < 25 * self.ESZ / 6.:
            if self.movex == 1:  # movex
                self.movex = 2
            else:
                self.movex = 1
            self.drawcanvas()
        yrotpos = 6.625 * self.ESZ
        xrotpos = self.SCROFS + 0.625 * self.ESZ
        srotpos = 0.75 * self.ESZ
        if xrotpos < touch.x < xrotpos + srotpos and yrotpos < touch.y < yrotpos + srotpos:
            self.clearhypersolid()  # rot Q
            if self.movex == 2:
                h5.rotxy (self.hs)
            else:
                h5.rotfcxy (self.fillcube)
            self.draw4d()
        xrotpos = self.SCROFS + 1.625 * self.ESZ
        if xrotpos < touch.x < xrotpos + srotpos and yrotpos < touch.y < yrotpos + srotpos:
            self.clearhypersolid()  # rot E
            if self.movex == 2:
                h5.rotyz (self.hs)
            else:
                h5.rotfcyz (self.fillcube)
            self.draw4d()
        xrotpos = self.SCROFS + 2.625 * self.ESZ
        if xrotpos < touch.x < xrotpos + srotpos and yrotpos < touch.y < yrotpos + srotpos:
            self.clearhypersolid()  # rot Y
            if self.movex == 2:
                h5.rotzu (self.hs)
            else:
                h5.rotfczu (self.fillcube)
            self.draw4d()
        xrotpos = self.SCROFS + 0.125 * self.ESZ
        yrotpos = 5.625 * self.ESZ
        if xrotpos < touch.x < xrotpos + srotpos and yrotpos < touch.y < yrotpos + srotpos:
            self.clearhypersolid()  # rot W
            if self.movex == 2:
                h5.rotxz (self.hs)
            else:
                h5.rotfcxz (self.fillcube)
            self.draw4d()
        yrotpos = 4.625 * self.ESZ
        if xrotpos < touch.x < xrotpos + srotpos and yrotpos < touch.y < yrotpos + srotpos:
            self.clearhypersolid()  # rot R
            if self.movex == 2:
                h5.rotxu (self.hs)
            else:
                h5.rotfcxu (self.fillcube)
            self.draw4d()
        yrotpos = 3.625 * self.ESZ
        if xrotpos < touch.x < xrotpos + srotpos and yrotpos < touch.y < yrotpos + srotpos:
            self.clearhypersolid()  # rot T
            if self.movex == 2:
                h5.rotyu (self.hs)
            else:
                h5.rotfcyu (self.fillcube)
            self.draw4d()
        if self.SCROFS + 0.125 * self.ESZ < touch.x < xrotpos + 1.875 * self.ESZ and 0.7083333333333333 * self.ESZ < touch.y < + 1.2916666666666667 * self.ESZ:
            self.clearhypersolid()  # skip hypersolid
            self.drawcanvas()
            self.hsindex = self.hsindex + 1
            if self.hsindex == self.totalhs:
                self.hsindex = 0
            self.hs = copy.deepcopy (self.hypersolids[self.hsindex])
            self.draw4d()
        if self.SCROFS + 0.125 * self.ESZ < touch.x < self.SCROFS + 0.7083333333333333 * self.ESZ and 2.4166666666666667 * self.ESZ - 1 < touch.y < 3 * self.ESZ:
            self.fcolor = self.fcolor_2_dark  # F6
            self.drawcanvas()
        if self.SCROFS + 0.7083333333333333 * self.ESZ + 1 < touch.x < self.SCROFS + 1.2916666666666667 * self.ESZ - 1 and 2.4166666666666667 * self.ESZ < touch.y < 3 * self.ESZ:
            self.fcolor = self.fcolor_def  # F5
            self.drawcanvas()
        if self.SCROFS + 1.2916666666666667 * self.ESZ + 1 < touch.x < self.SCROFS + 1.875 * self.ESZ and 2.4166666666666667 * self.ESZ < touch.y < 3 * self.ESZ:
            self.fcolor = self.fcolor_1_dark  # F7
            self.drawcanvas()
        if self.SCROFS + 4.75 * self.ESZ < touch.x < self.SCROFS + 7.25 * self.ESZ and  0.5 * self.ESZ < touch.y < 1.5 * self.ESZ:
            if self.dropOK == True:  # drop hypersolid
                for e in range (len(self.hs1)):
                    self.hs1 = copy.deepcopy (self.hs)
                    h5.uzyx01 (self.hs1)
                    self.fillcube [self.hs1[e][0]] [self.hs1[e][1]] [self.hs1[e][2]] [self.hs1[e][3]] ^= 3
                self.hypervolume = self.hypervolume + len (self.hs)
                if self.hypervolume == 16:
                    Clock.schedule_once (self.endpause, 3)
                    del self.hypersolids[self.hsindex]
                    self.drawcanvas()
                    self.totalhs = self.totalhs - 1
                    self.hs = []
                    return True
                del self.hypersolids[self.hsindex]
                self.drawcanvas()
                self.totalhs = self.totalhs - 1
                if self.hsindex == self.totalhs:
                    self.hsindex = 0
                self.NoUserInputs = True
                Clock.schedule_once (self.droppause, 1.25)
                self.hs = copy.deepcopy (self.hypersolids[self.hsindex])
        if self.SCROFS + 6.32 * self.ESZ < touch.x < self.SCROFS + 7 * self.ESZ and 4.32 * self.ESZ < touch.y < 5 * self.ESZ:
            self.clearhypersolid()  # move 1
            h5.moviz (self.hs)
            self.draw4d()
        if self.SCROFS + 7.06 * self.ESZ < touch.x < self.SCROFS + 7.74 * self.ESZ and 4.35 * self.ESZ < touch.y < 5.03 * self.ESZ:
            self.clearhypersolid()  # move 2
            h5.moviy (self.hs)
            self.draw4d()
        if self.SCROFS + 7.8 * self.ESZ < touch.x < self.SCROFS + 8.48 * self.ESZ and 4.32 * self.ESZ < touch.y < 5 * self.ESZ:
            self.clearhypersolid()  # move 3
            h5.moviu (self.hs)
            self.draw4d()
        if self.SCROFS + 6.35 * self.ESZ < touch.x < self.SCROFS + 7.03 * self.ESZ and 5.06 * self.ESZ < touch.y < 5.74 * self.ESZ:
            self.clearhypersolid()  # move 4
            h5.movix (self.hs)
            self.draw4d()
        if self.SCROFS + 7.77 * self.ESZ < touch.x < self.SCROFS + 8.45 * self.ESZ and 5.06 * self.ESZ < touch.y < 5.74 * self.ESZ:
            self.clearhypersolid()  # move 6
            h5.movx (self.hs)
            self.draw4d()
        if self.SCROFS + 6.32 * self.ESZ < touch.x < self.SCROFS + 7 * self.ESZ and 5.8 * self.ESZ < touch.y < 6.48 * self.ESZ:
            self.clearhypersolid()  # move 7
            h5.movu (self.hs)
            self.draw4d()
        if self.SCROFS + 7.06 * self.ESZ < touch.x < self.SCROFS + 7.74 * self.ESZ and 5.77 * self.ESZ < touch.y < 6.45 * self.ESZ:
            self.clearhypersolid()  # move 8
            h5.movy (self.hs)
            self.draw4d()
        if self.SCROFS + 7.8 * self.ESZ < touch.x < self.SCROFS + 8.48 * self.ESZ and 5.8 * self.ESZ < touch.y < 6.48 * self.ESZ:
            self.clearhypersolid()  # move 9
            h5.movz (self.hs)
            self.draw4d()
        if self.SCROFS + 7.84 * self.ESZ < touch.x < self.SCROFS + 8.44 * self.ESZ and 2.7 * self.ESZ < touch.y < 3.3 * self.ESZ:
            self.clearhypersolid()  # restart
            self.fillcube = [ [ [ [ 0 for l in range(2) ] for k in range(2) ] for j in range(2) ] for i in range(2) ]
            self.movex = 2
            self.hs = []
            self.hs1 = []
            self.NoUserInputs = False
            self.hsindex = 0
            self.hypervolume = 0
            self.dropOK = False
            self.hypersolids = []
            self.totalhs = 0
            self.init_hypersolids()
            self.hs = copy.deepcopy (self.hypersolids[0])
            self.draw4d()


    def draw4d(self):
        self.hs1 = copy.deepcopy (self.hs)
        h5.uzyx01 (self.hs1)  # convert coordinates (u,z,y,x) from {-1, +1} in hs to {0, 1} in hs1
        self.dropOK = True
        for e in range (len(self.hs1)):
            self.fillcube [self.hs1[e][0]] [self.hs1[e][1]] [self.hs1[e][2]] [self.hs1[e][3]] ^= 2
            if self.fillcube [self.hs1[e][0]] [self.hs1[e][1]] [self.hs1[e][2]] [self.hs1[e][3]] == 3:
                self.dropOK = False
        self.drawcanvas()


    def clearhypersolid(self):
        self.hs1 = copy.deepcopy (self.hs)
        h5.uzyx01 (self.hs1)
        for e in range (len(self.hs1)):
            self.fillcube [self.hs1[e][0]] [self.hs1[e][1]] [self.hs1[e][2]] [self.hs1[e][3]] ^= 2


    def droppause(self,  dt):
        self.draw4d()
        self.NoUserInputs = False


    def endpause(self,  dt):
        Clock.schedule_once (self.endpause2, 12.5)
        with self.canvas:
            Color (1, 0.5, 0)
            Ellipse (pos = ( self.SCROFS + 6.25 * self.ESZ, self.ESZ ), size = ( 1.5 * self.ESZ, 1.5 * self.ESZ ))
            Color (0, 0.15, 0.3)
            Ellipse (pos = ( self.SCROFS + 6.3125 * self.ESZ, 1.0625 * self.ESZ ), size = ( 1.375 * self.ESZ, 1.375 * self.ESZ ))
            Color (1, 0.5, 0)
            Triangle (points = ( self.SCROFS + 7 * self.ESZ, 2.375 * self.ESZ,  self.SCROFS + 6.63263421732 * self.ESZ, 1.24436437852 * self.ESZ, self.SCROFS + 7 * self.ESZ, 1.51127124297 * self.ESZ ))
            Triangle (points = ( self.SCROFS + 7 * self.ESZ, 2.375 * self.ESZ,  self.SCROFS + 7.36736578268 * self.ESZ, 1.24436437852 * self.ESZ, self.SCROFS + 7 * self.ESZ, 1.51127124297 * self.ESZ ))
            Triangle (points = ( self.SCROFS + 6.85967875732 * self.ESZ, 1.94313562148 * self.ESZ,  self.SCROFS + 6.40558967732 * self.ESZ, 1.94313562148 * self.ESZ, self.SCROFS + 6.77295546 * self.ESZ, 1.67622875703 * self.ESZ ))
            Triangle (points = ( self.SCROFS + 7.14032124268 * self.ESZ, 1.94313562148 * self.ESZ,  self.SCROFS + 7.59441032268 * self.ESZ, 1.94313562148 * self.ESZ, self.SCROFS + 7.22704454 * self.ESZ, 1.67622875703 * self.ESZ ))


    def endpause2(self,  dt):
        exit()


    def startpause(self,  dt):
        self.drawcanvas()


    def update(self,  dt):
        pass


    def drawcanvas(self):
        self.ESZ = min ( self.width / 8.8, self.height / 8. )
        if self.ESZ < 15:
            Clock.schedule_once (self.startpause, 0.2)
            return
        self.SCROFS = ( self.width - 1.1 * self.height ) / 2
        if self.SCROFS < 0:
            self.SCROFS = 0
        with self.canvas:
            self.canvas.clear()
            ###  u=0, z=0
            Color (1, 1, 1)
            Line (points = (self.SCROFS + 2 * self.ESZ, 1 * self.ESZ, self.SCROFS + 4 * self.ESZ, 1 * self.ESZ, self.SCROFS + 4 * self.ESZ, 3 * self.ESZ, self.SCROFS + 2 * self.ESZ, 3 * self.ESZ, self.SCROFS + 2 * self.ESZ, 1 * self.ESZ))
            Line (points = (self.SCROFS + 3 * self.ESZ, 1 * self.ESZ, self.SCROFS + 3 * self.ESZ, 3 * self.ESZ))
            Line (points = (self.SCROFS + 2 * self.ESZ, 2 * self.ESZ, self.SCROFS + 4 * self.ESZ, 2 * self.ESZ))
            #  y=0, x=0
            Color (*self.fcolor[ self.fillcube[0][0][0][0] ])
            Rectangle (pos = ( self.SCROFS + 2 * self.ESZ + 1, 1 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=0, x=1    
            Color (*self.fcolor[ self.fillcube[0][0][0][1] ])
            Rectangle (pos = ( self.SCROFS + 3 * self.ESZ + 1, 1 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=0    
            Color (*self.fcolor[ self.fillcube[0][0][1][0] ])
            Rectangle (pos = ( self.SCROFS + 2 * self.ESZ + 1, 2 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=1    
            Color (*self.fcolor[ self.fillcube[0][0][1][1] ])
            Rectangle (pos = ( self.SCROFS + 3 * self.ESZ + 1, 2 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            ###  u=0, z=1
            Color (1, 1, 1)
            Line (points = (self.SCROFS + 5 * self.ESZ, 2 * self.ESZ, self.SCROFS + 7 * self.ESZ, 2 * self.ESZ, self.SCROFS + 7 * self.ESZ, 4 * self.ESZ, self.SCROFS + 5 * self.ESZ, 4 * self.ESZ, self.SCROFS + 5 * self.ESZ, 2 * self.ESZ))
            Line (points = (self.SCROFS + 6 * self.ESZ, 2 * self.ESZ, self.SCROFS + 6 * self.ESZ, 4 * self.ESZ))
            Line (points = (self.SCROFS + 5 * self.ESZ, 3 * self.ESZ, self.SCROFS + 7 * self.ESZ, 3 * self.ESZ))
            #  y=0, x=0
            Color (*self.fcolor[ self.fillcube[0][1][0][0] ])
            Rectangle (pos = ( self.SCROFS + 5 * self.ESZ + 1, 2 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=0, x=1    
            Color (*self.fcolor[ self.fillcube[0][1][0][1] ])
            Rectangle (pos = ( self.SCROFS + 6 * self.ESZ + 1, 2 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=0    
            Color (*self.fcolor[ self.fillcube[0][1][1][0] ])
            Rectangle (pos = ( self.SCROFS + 5 * self.ESZ + 1, 3 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=1    
            Color (*self.fcolor[ self.fillcube[0][1][1][1] ])
            Rectangle (pos = ( self.SCROFS + 6 * self.ESZ + 1, 3 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            ###  u=1, z=0
            Color (1, 1, 1)
            Line (points = (self.SCROFS + 1 * self.ESZ, 4 * self.ESZ, self.SCROFS + 3 * self.ESZ, 4 * self.ESZ, self.SCROFS + 3 * self.ESZ, 6 * self.ESZ, self.SCROFS + 1 * self.ESZ, 6 * self.ESZ, self.SCROFS + 1 * self.ESZ, 4 * self.ESZ))
            Line (points = (self.SCROFS + 2 * self.ESZ, 4 * self.ESZ, self.SCROFS + 2 * self.ESZ, 6 * self.ESZ))
            Line (points = (self.SCROFS + 1 * self.ESZ, 5 * self.ESZ, self.SCROFS + 3 * self.ESZ, 5 * self.ESZ))
            #  y=0, x=0
            Color (*self.fcolor[ self.fillcube[1][0][0][0] ])
            Rectangle (pos = ( self.SCROFS + 1 * self.ESZ + 1, 4 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=0, x=1    
            Color (*self.fcolor[ self.fillcube[1][0][0][1] ])
            Rectangle (pos = ( self.SCROFS + 2 * self.ESZ + 1, 4 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=0    
            Color (*self.fcolor[ self.fillcube[1][0][1][0] ])
            Rectangle (pos = ( self.SCROFS + 1 * self.ESZ + 1, 5 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=1    
            Color (*self.fcolor[ self.fillcube[1][0][1][1] ])
            Rectangle (pos = ( self.SCROFS + 2 * self.ESZ + 1, 5 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            ###  u=1, z=1
            Color (1, 1, 1)
            Line (points = (self.SCROFS + 4 * self.ESZ, 5 * self.ESZ, self.SCROFS + 6 * self.ESZ, 5 * self.ESZ, self.SCROFS + 6 * self.ESZ, 7 * self.ESZ, self.SCROFS + 4 * self.ESZ, 7 * self.ESZ, self.SCROFS + 4 * self.ESZ, 5 * self.ESZ))
            Line (points = (self.SCROFS + 5 * self.ESZ, 5 * self.ESZ, self.SCROFS + 5 * self.ESZ, 7 * self.ESZ))
            Line (points = (self.SCROFS + 4 * self.ESZ, 6 * self.ESZ, self.SCROFS + 6 * self.ESZ, 6 * self.ESZ))
            #  y=0, x=0
            Color (*self.fcolor[ self.fillcube[1][1][0][0] ])
            Rectangle (pos = ( self.SCROFS + 4 * self.ESZ + 1, 5 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=0, x=1    
            Color (*self.fcolor[ self.fillcube[1][1][0][1] ])
            Rectangle (pos = ( self.SCROFS + 5 * self.ESZ + 1, 5 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=0    
            Color (*self.fcolor[ self.fillcube[1][1][1][0] ])
            Rectangle (pos = ( self.SCROFS + 4 * self.ESZ + 1, 6 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            #  y=1, x=1    
            Color (*self.fcolor[ self.fillcube[1][1][1][1] ])
            Rectangle (pos = ( self.SCROFS + 5 * self.ESZ + 1, 6 * self.ESZ + 1 ), size = ( self.ESZ - 2, self.ESZ - 2 ))

            ### movex circle
            Color (*self.fcolor_def[ self.movex ])
            Ellipse (pos = ( self.SCROFS + 23./6 * self.ESZ, 23./6 * self.ESZ ), size = ( self.ESZ / 3., self.ESZ / 3. ))
            
            ### rot Q xy = orange
            yrotpos = 6.625 * self.ESZ
            Color (1,  0.4,  0)
            Ellipse (pos = ( self.SCROFS + 0.625 * self.ESZ, yrotpos ), size = ( 0.75 * self.ESZ, 0.75 * self.ESZ ))

            ### rot E xu = green
            Color (0,  1,  0)
            Ellipse (pos = ( self.SCROFS + 1.625 * self.ESZ, yrotpos ), size = ( 0.75 * self.ESZ, 0.75 * self.ESZ ))

            ### rot Y yu = bright blue
            Color (0.4,  0.6,  1)
            Ellipse (pos = ( self.SCROFS + 2.625 * self.ESZ, yrotpos ), size = ( 0.75 * self.ESZ, 0.75 * self.ESZ ))

            ### rot W xz = purple
            xrotpos = self.SCROFS + 0.125 * self.ESZ
            Color (1,  0,  1)
            Ellipse (pos = ( xrotpos, 5.625 * self.ESZ ), size = ( 0.75 * self.ESZ, 0.75 * self.ESZ ))

            ### rot R xu = pink
            Color (1,  0.6,  0.6)
            Ellipse (pos = ( xrotpos, 4.625 * self.ESZ ), size = ( 0.75 * self.ESZ, 0.75 * self.ESZ ))

            ### rot T yu = bright yellow
            Color (1,  1,  0.4)
            Ellipse (pos = ( xrotpos, 3.625 * self.ESZ ), size = ( 0.75 * self.ESZ, 0.75 * self.ESZ ))
            
            ### skip
            Color (0.4,  0.4,  0.4)
            Rectangle (pos = ( self.SCROFS + 0.125 * self.ESZ,  0.7083333333333333 * self.ESZ ),  size = ( 1.75 * self.ESZ,  1.75/3 * self.ESZ ))
            Color (1,  1,  1)
            xyminpos = 0.8055555555555556 * self.ESZ
            xymaxpos = 1.1944444444444444 * self.ESZ
            Line (points = ( self.SCROFS + xyminpos, xyminpos, self.SCROFS + xymaxpos, xymaxpos ))
            Line (points = ( self.SCROFS + xyminpos, xymaxpos, self.SCROFS + xymaxpos, xyminpos ))
            
            ### F6 F5 F7
            Color (*self.fcolor_def[1])
            Rectangle (pos = ( self.SCROFS + 0.125 * self.ESZ,  2.4166666666666667 * self.ESZ ),  size = ( 1.75/3 * self.ESZ,  1.75/3 * self.ESZ ))
            Color (*self.fcolor_def[3])
            Rectangle (pos = ( self.SCROFS + 0.7083333333333333 * self.ESZ,  2.4166666666666667 * self.ESZ ),  size = ( 1.75/3 * self.ESZ,  1.75/3 * self.ESZ ))
            Color (*self.fcolor_def[2])
            Rectangle (pos = ( self.SCROFS + 1.2916666666666667 * self.ESZ,  2.4166666666666667 * self.ESZ ),  size = ( 1.75/3 * self.ESZ,  1.75/3 * self.ESZ ))
            Color (1,  1,  1)
            xminpos = self.SCROFS + 0.2708333333333333 * self.ESZ
            xmaxpos = self.SCROFS + 0.5625 * self.ESZ
            ymmpos = 2.708333333333333 * self.ESZ
            Line (points = ( xminpos, ymmpos, xmaxpos, ymmpos ))
            xminpos = self.SCROFS + 1.4375 * self.ESZ
            xmaxpos = self.SCROFS + 1.729166666666667 * self.ESZ
            Line (points = ( xminpos, ymmpos, xmaxpos, ymmpos ))
            
            ### drop
            Color (0.5,  0.65,  0.5)
            Rectangle (pos = ( self.SCROFS + 4.75 * self.ESZ,  0.5 * self.ESZ ),  size = ( 2.5 * self.ESZ,  self.ESZ ))
            
            ### move
            Color (0.4,  0.4,  0.4)
            Rectangle (pos = ( self.SCROFS + 6.32 * self.ESZ,  4.32 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Rectangle (pos = ( self.SCROFS + 7.06 * self.ESZ,  4.35 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Rectangle (pos = ( self.SCROFS + 7.80 * self.ESZ,  4.32 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Rectangle (pos = ( self.SCROFS + 6.35 * self.ESZ,  5.06 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Rectangle (pos = ( self.SCROFS + 7.77 * self.ESZ,  5.06 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Rectangle (pos = ( self.SCROFS + 6.32 * self.ESZ,  5.80 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Rectangle (pos = ( self.SCROFS + 7.06 * self.ESZ,  5.77 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Rectangle (pos = ( self.SCROFS + 7.80 * self.ESZ,  5.80 * self.ESZ ),  size = ( 0.68 * self.ESZ,  0.68 * self.ESZ ))
            Color (1,  1,  1)
            Line (points = ( self.SCROFS + 7.88 * self.ESZ, 5.40 * self.ESZ, self.SCROFS + 8.34 * self.ESZ, 5.40 * self.ESZ ))
            Line (points = ( self.SCROFS + 8.24 * self.ESZ, 5.50 * self.ESZ, self.SCROFS + 8.34 * self.ESZ, 5.40 * self.ESZ, self.SCROFS + 8.24 * self.ESZ, 5.30 * self.ESZ ))
            Line (points = ( self.SCROFS + 6.46 * self.ESZ, 5.40 * self.ESZ, self.SCROFS + 6.92 * self.ESZ, 5.40 * self.ESZ ))
            Line (points = ( self.SCROFS + 6.56 * self.ESZ, 5.50 * self.ESZ, self.SCROFS + 6.46 * self.ESZ, 5.40 * self.ESZ, self.SCROFS + 6.56 * self.ESZ, 5.30 * self.ESZ ))
            Line (points = ( self.SCROFS + 7.40 * self.ESZ, 4.92 * self.ESZ, self.SCROFS + 7.40 * self.ESZ, 4.46 * self.ESZ ))
            Line (points = ( self.SCROFS + 7.30 * self.ESZ, 4.56 * self.ESZ, self.SCROFS + 7.40 * self.ESZ, 4.46 * self.ESZ, self.SCROFS + 7.50 * self.ESZ, 4.56 * self.ESZ ))
            Line (points = ( self.SCROFS + 7.40 * self.ESZ, 6.34 * self.ESZ, self.SCROFS + 7.40 * self.ESZ, 5.88 * self.ESZ ))
            Line (points = ( self.SCROFS + 7.30 * self.ESZ, 6.24 * self.ESZ, self.SCROFS + 7.40 * self.ESZ, 6.34 * self.ESZ, self.SCROFS + 7.50 * self.ESZ, 6.24 * self.ESZ ))
            Line (points = ( self.SCROFS + 6.43 * self.ESZ, 4.43 * self.ESZ, self.SCROFS + 6.89 * self.ESZ, 4.89 * self.ESZ ))
            Line (points = ( self.SCROFS + 6.43 * self.ESZ, 4.57 * self.ESZ, self.SCROFS + 6.43 * self.ESZ, 4.43 * self.ESZ, self.SCROFS + 6.57 * self.ESZ, 4.43 * self.ESZ ))
            Line (points = ( self.SCROFS + 8.37 * self.ESZ, 4.43 * self.ESZ, self.SCROFS + 7.91 * self.ESZ, 4.89 * self.ESZ ))
            Line (points = ( self.SCROFS + 8.23 * self.ESZ, 4.43 * self.ESZ, self.SCROFS + 8.37 * self.ESZ, 4.43 * self.ESZ, self.SCROFS + 8.37 * self.ESZ, 4.57 * self.ESZ ))
            Line (points = ( self.SCROFS + 6.43 * self.ESZ, 6.37 * self.ESZ, self.SCROFS + 6.89 * self.ESZ, 5.91 * self.ESZ ))
            Line (points = ( self.SCROFS + 6.43 * self.ESZ, 6.23 * self.ESZ, self.SCROFS + 6.43 * self.ESZ, 6.37 * self.ESZ, self.SCROFS + 6.57 * self.ESZ, 6.37 * self.ESZ ))
            Line (points = ( self.SCROFS + 7.91 * self.ESZ, 5.91 * self.ESZ, self.SCROFS + 8.37 * self.ESZ, 6.37 * self.ESZ ))
            Line (points = ( self.SCROFS + 8.23 * self.ESZ, 6.37 * self.ESZ, self.SCROFS + 8.37 * self.ESZ, 6.37 * self.ESZ, self.SCROFS + 8.37 * self.ESZ, 6.23 * self.ESZ ))
            
            ### restart
            Color (0.9, 0, 0.45)
            Triangle (points = ( self.SCROFS + 7.84 * self.ESZ, 2.7 * self.ESZ,  self.SCROFS + 8.44 * self.ESZ, 2.7 * self.ESZ, self.SCROFS + 8.14 * self.ESZ, 3.3 * self.ESZ ))
            Color (0, 0, 0)
            Rectangle (pos = ( self.SCROFS + 8.14 * self.ESZ - 1, 2.79 * self.ESZ ),  size = ( 3, 0.37 * self.ESZ ))


    def init_hypersolids(self):
        if self.gamenr == 2:
            self.hypersolids.append (h5.h5d4)
            self.hypersolids.append (h5.h5c4)
            self.hypersolids.append (h5.h4b3)
            self.hypersolids.append (h5.h2a1)
        elif self.gamenr == 3:
            self.hypersolids.append (h5.h5b3)
            self.hypersolids.append (h5.h4c3)
            self.hypersolids.append (h5.h4a2)
            self.hypersolids.append (h5.h3a2)
        elif self.gamenr == 4:
            self.hypersolids.append (h5.h5d4)
            self.hypersolids.append (h5.h5b3)
            self.hypersolids.append (h5.h5a3)
            self.hypersolids.append (h5.h1a0)
        elif self.gamenr == 5:
            self.hypersolids.append (h5.h5c4)
            self.hypersolids.append (h5.h4b3)
            self.hypersolids.append (h5.h4a2)
            self.hypersolids.append (h5.h3a2)            
        elif self.gamenr == 6:
            self.hypersolids.append (h5.h5d4)
            self.hypersolids.append (h5.h5c4)
            self.hypersolids.append (h5.h5b3)
            self.hypersolids.append (h5.h1a0)
        elif self.gamenr == 7:
            self.hypersolids.append (h5.h5e4)
            self.hypersolids.append (h5.h5c4)
            self.hypersolids.append (h5.h5a3)
            self.hypersolids.append (h5.h1a0)
        else:  # gamenr == 1
            self.hypersolids.append (h5.h5f4)
            self.hypersolids.append (h5.h5e4)
            self.hypersolids.append (h5.h3a2)
            self.hypersolids.append (h5.h2a1)
            self.hypersolids.append (h5.h1a0)

        self.totalhs = len (self.hypersolids)        


    fillcube = [ [ [ [ 0 for l in range(2) ] for k in range(2) ] for j in range(2) ] for i in range(2) ]
    movex = 2
    hs = []
    hs1 = []
    NoUserInputs = False
    ESZ = 10.5
    
    fcolor_def = [ (0, 0, 0), (0, 0.125, 1), (1, 0, 0), (1, 0, 1) ]
    fcolor_1_dark = [ (0, 0, 0), (0, 0.05, 0.2), (1, 0, 0), (1, 0, 0.125) ]
    fcolor_2_dark = [ (0, 0, 0), (0, 0.125, 1), (0.125, 0, 0), (0.125, 0, 1) ]
    fcolor = fcolor_def
    
    hsindex = 0
    hypervolume = 0
    dropOK = False
    hypersolids = []
    totalhs = 0
    gamenr = 1
    SCROFS = 0.

class Cube4DApp(App):
    def build (self):
        game4d = CubeGame ( GameNumber = ChooseGameApp.gamenr )
        return game4d


if __name__ == '__main__':
    ChooseGameApp().run()
    print 'Game Number',  ChooseGameApp.gamenr

    Cube4DApp().run()

